#include <bits/stdc++.h>
#define endl "\n"
using namespace std;

long long ans[20004],red[2004];

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    long long s,n;
    cin>>s>>n;
    for(int i=0;i<n;i++)cin>>red[i];
    for(int i=1;i<=s;i++){
            ans[i]=100000007;
        for(int j=0;j<n;j++){
            if(i-red[j]>=0){
                ans[i]=min(ans[i],ans[i-red[j]]+1);
            }
        }
    }
    cout<<ans[s]<<endl;

    return 0;
}
